import { _decorator, Component, director, instantiate, log, Node, Prefab, resources, Vec3 } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('edit_test')
export class edit_test extends Component {

    private _prefab: { [name: string]: Prefab } = {};

    start() {

        this.loadPrefab();

        this.scheduleOnce(()=>{
            this.inst(this.getpre('edit'),this.node);
        },3);
    }

    update(deltaTime: number) {
        
    }

    getpre(name:string){
        return this._prefab[name];
    }
    setpre(asset:any){
        this._prefab[asset.name] = asset;

    }
    loadPrefab(){
        resources.load('edit',Prefab,(err,asset)=>{
            if(asset){
              this.setpre(asset);
            }
        });
    }

    public inst(asset: Prefab, root: Node | undefined = undefined, pos: Vec3 = Vec3.ZERO): Node {
        const instObj = instantiate(asset);
        if (root === undefined) {
            director.getScene()?.addChild(instObj);
        } else {
            instObj.setParent(root);
        }
        instObj.setPosition(pos);
        instObj.setScale(Vec3.ONE);
        return instObj;
    }
}


